from java.awt import Font,Color
from jhplot  import  HPlot,P1D,HLabel,HKey
from jhplot.shapes  import Line,Arrow,Rectan
import sys

sys.path.append("/home/sergei/work/workspace/jhepwork/jehep/macros/examples/advanced")
sys.path.append(".")
from Measurement1  import *

#print dir()

massAverage=1525
massError=5

widthAverage=73
widthError=6


# fill world's measurements
all=[]
all.append( Measurement1('K-meson experiments',   1523.4 ,0.0, 1.3,1.3,   80.2,0.0, 2.6,2.6) )
all.append( Measurement1('e^{+}e^{-} experiments',   1520.7, 0.0, 2, 2,   79.9, 0.0, 3.3,3.3) )
all.append( Measurement1('p #bar{p} experiments',   1513.0, 0.0, 4, 4,   76.0, 0.0, 6,6) )
all.append( Measurement1('ZEUS e p DIS', 1537, 0, 8, 9,  50, 0, 22, 34) )
all.append( Measurement1('ZEUS e p (prel.) 0.5 fb^{-1}',  1515, 2, 1, 3,  66.5, 5, 6, 18) )



c1 = HPlot("Canvas",800,600,3, 1)
c1.setGTitle("f_{2}^{'} (1525) world's summary")
c1.setGridAll(0,0)
c1.setGridAll(1,0)
c1.visible(1)


# plot masses
c1.cd(1,1)
c1.removeAxes()
c1.setRange(1505,1550,0,100)
c1.setAxisX()
c1.setNameX("mass (MeV)") 
c1.setAxisPenTicWidth(3)
c1.setPenWidthAxis(3)

# c1.setMarginSizeLeft(0.001)
# c1.setMarginSizeRight(1)
#c1.setMarginPanelLeft(1.1)
#c1.setMarginPanelRight(1.1)
# c1.setRange(1505,1550,0,100)

# a=c1.getMarginPanelLeft()
# print a
# c1.getMarginPanelRight()
# c1.getMarginPanelTop()
# c1.getMarginPanelBottom()


# show PDG masses
line = Line(massAverage,0.0, massAverage, 100)
line.setColor(Color.red)
line.setTransparency(0.99)
c1.add(line)
rec = Rectan(massAverage,50, massError, 100)
rec.setColor(Color.yellow)
rec.setTransparency(0.5)
rec.setFill(1)
c1.add(rec)

tot=len(all)
delta=100/(tot+1)
for i in range(len(all)):
             m=all[i]
             m.printMass()
             m.setY(delta+i*delta)
             c1.draw(m.getMass())


# c1.setMarginSizeRight(1)
# c1.update()

# -------- citation
c1.cd(2,1)
c1.setRange(0,100,0,100)
c1.removeAxes()
# c1.setMarginSizeLeft(1)
# c1.setMarginSizeRight(1)

# c1.setRange(0,100,0,100)
# put key

key=HKey("PDG",10,10)
key.setKey(20,7,Color.yellow)
key.setKeySpace(2)
c1.add(key)
key=HKey("",10.4,9.8)
key.setKey(30,6.5,Color.red)
key.setKeySpace(3)
c1.add(key)


for i in range(len(all)):
             m=all[i]
             print "Labels=", m.printMass()
             lab=m.getLabel()
             lab.setLocation(10, 1.45*delta+i*delta*0.98, "USER")
             c1.add(m.getLabel())


# c1.setMarginSizeLeft(0.001)
# c1.setMarginSizeRight(0.001)
# c1.update()



# -------- plot widthes --------------------------------

c1.cd(3,1)
c1.removeAxes()
c1.setRange(20,95,0,100)
c1.setAxisX()
c1.setNameX("width (MeV)")
# c1.setAxisPenTicWidth(3)
c1.setPenWidthAxis(3)
c1.setMarginSizeLeft(-3)
# c1.setMarginSizeRight(0.02)

line = Line(widthAverage,0.0, widthAverage, 100)
line.setColor(Color.red)
line.setTransparency(0.99)
c1.add(line)
rec = Rectan(widthAverage,50, widthError, 100)
rec.setColor(Color.yellow)
rec.setTransparency(0.5)
rec.setFill(1)
c1.add(rec)



for i in range(len(all)):
             m=all[i]
             m.printWidth()
             m.setY(delta+i*delta)
             c1.draw(m.getWidth())

c1.updateAll()

c1.export(Editor.DocMasterName()+".png")



