#  Function example. Parametric function examples (HPlot3DP).


"""
This example shows a few parametric functions. As example, we define
a fnction $f1$ as:
$$
x=r*\sin(2*\pi*u), \qquad y=r*\cos(2*\pi*u), \quad z=1.5*ir*\cos(\pi*v)
$$
where $ir=0.3+.1*\sin(4*\pi*u)$ and  $r=ir*\sin(2*\pi*v)+0.5$
"""

from java.awt import Color
from jhplot import * 



c1 = HPlot3DP("Canvas",600,600,2,1)
c1.setGTitle('3D surfaces')
c1.visible();

f1=FPR('ir=.3+.1*sin(4*Pi*u); r=ir*sin(2*Pi*v)+.5; \
        x=r*sin(2*Pi*u); y=r*cos(2*Pi*u); z=1.5*ir*cos(Pi*v)')
f2=FPR('u=-2+4u; v=-2+4v; x=u-(u*u*u/3)+u*v*v; \
        y=v-(v*v*v/3)+u*u*v; z=u*u-v*v; n=10; x=x/n; y=y/n; z=z/n')

c1.cd(1,1)
c1.draw(f1)

c1.cd(2,1)
c1.draw(f2)
